//
//  AppDelegate.m
//  Navsea Controller
//
//  Created by Kristopher Krasnosky on 7/12/13.
//  Copyright (c) 2013 Faraway5. All rights reserved.
//

#import "AppDelegate.h"

@implementation AppDelegate
@synthesize  addrField;
@synthesize  portField;
@synthesize steerSlider;
@synthesize rangerVal;
@synthesize rangerBar;
@synthesize powSlider;
@synthesize quarterRangerBar;
@synthesize quarterRangerVal;
@synthesize sideRangerBar;
@synthesize sideRangerVal;


- (void)applicationDidFinishLaunching:(NSNotification *)aNotification
{
	udpSocket = [[AsyncUdpSocket alloc] initWithDelegate:self];
	
	NSError *error = nil;
	
	if (![udpSocket bindToPort:0 error:&error])
	{
		NSLog(@"Error binding: %@", error);
		return;
	}
	
	[udpSocket receiveWithTimeout:-1 tag:0];
	
	NSLog(@"Ready");
    
}


- (IBAction)setSteer:(id)sender {
    // all string sent to and fromt he adruino are in the format "command:1234"  string:int
    
    //              [class    method:          @"string:%@,[the value from the slider]]    NOTE:  %@ means insert string after comma here
    NSString *msg = [NSString stringWithFormat:@"steer:%@",[steerSlider stringValue]];   // create a string to send and format it.
    
    [self send:msg];   // send the message
    NSLog(@"updated slider position %@",[steerSlider stringValue]);   // log what we did
    return;
}

- (IBAction)setPow:(id)sender {
    NSString *msg = [NSString stringWithFormat:@"pow:%@",[powSlider stringValue]];
    [self send:msg];
    NSLog(@"updated powSlider position %@",[powSlider stringValue]);
    return;

}

- (IBAction)setAuto:(id)sender {
    NSString *msg = [NSString stringWithFormat:@"auto:0"];
    [self send:msg];
    msg = [NSString stringWithFormat:@":0"];   // this message will clear the buffer in the arduino
    [self send:msg];
    NSLog(@"auto mode sent");
    return;

}

- (IBAction)setManual:(id)sender {
    NSString *msg = [NSString stringWithFormat:@"manu:0"];
    [self send:msg];
    msg = [NSString stringWithFormat:@":0"]; // this message will clear the buffer in the arduino
    [self send:msg];
    NSLog(@"manual mode sent");
    
    
    // the methods below initialize the power settings and the steering settings on the arduino to the
    // ones that are set currently on the sliders
    msg = [NSString stringWithFormat:@"steer:%@",[steerSlider stringValue]];
    [self send:msg];
    NSLog(@"updated slider position %@",[steerSlider stringValue]);
    
    
    msg = [NSString stringWithFormat:@"pow:%@",[powSlider stringValue]];
    [self send:msg];
    NSLog(@"updated powSlider position %@",[powSlider stringValue]);
    
    
    return;
}

- (void)send:(NSString *)msg{
    
    NSString *host = [addrField stringValue];
	if ([host length] == 0)
	{
		NSLog( @"Address required");
		return;
	}
	
	int port = [portField intValue];
	if (port <= 0 || port > 65535)
	{
		NSLog(@"Valid port required");
		return;
	}
	
	
	NSData *data = [msg dataUsingEncoding:NSUTF8StringEncoding];
	[udpSocket sendData:data toHost:host port:port withTimeout:-1 tag:tag];
	
    
	tag++;
}



/**
 **     UDP socket delegate stuff
 **/


- (BOOL)onUdpSocket:(AsyncUdpSocket *)sock
     didReceiveData:(NSData *)data
            withTag:(long)tag
           fromHost:(NSString *)host
               port:(UInt16)port
{
	NSString *msg = [[NSString alloc] initWithData:data encoding:NSUTF8StringEncoding];
	if (msg){
        NSLog(@"Message Recieved: %@",msg);
    }
    if ([msg rangeOfString:@"fRange:"].location != NSNotFound){   // if the message rRange: is found
        
        // get find the find the number after the fRange: command 
        NSRange range = [msg rangeOfString:@"fRange:"];
        NSString *substring = [[msg substringFromIndex:NSMaxRange(range)] stringByTrimmingCharactersInSet:[NSCharacterSet whitespaceCharacterSet]];
        
        
        NSLog(@"%@",substring);// log the substring to make sure it is parsing corretly
        
        
        
        [rangerVal setStringValue:substring];   //  set the rangerVal  (the label) to the string
            
        [rangerBar setFloatValue:[substring floatValue]];   // set the rangerBar value Note we had to get the substring's float value to send to
        // the set float value method
    }
    
    if ([msg rangeOfString:@"qRange:"].location != NSNotFound){
        NSRange range = [msg rangeOfString:@"qRange:"];
        NSString *substring = [[msg substringFromIndex:NSMaxRange(range)] stringByTrimmingCharactersInSet:[NSCharacterSet whitespaceCharacterSet]];
        NSLog(@"%@",substring);
        [quarterRangerVal setStringValue:substring];
        
        [quarterRangerBar setFloatValue:[substring floatValue]];
    }

    if ([msg rangeOfString:@"sRange:"].location != NSNotFound){
        NSRange range = [msg rangeOfString:@"sRange:"];
        NSString *substring = [[msg substringFromIndex:NSMaxRange(range)] stringByTrimmingCharactersInSet:[NSCharacterSet whitespaceCharacterSet]];
        NSLog(@"%@",substring);
        [sideRangerVal setStringValue:substring];
        
        [sideRangerBar setFloatValue:[substring floatValue]];
    }

	
	
	[udpSocket receiveWithTimeout:-1 tag:0];
	return YES;
}




@end
